kernel hangs with earlyprintk on highbank

Bug #1034781 reported by Ike Panhc on 2012-08-09
18
This bug affects 2 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
High
Li Li
Quantal
High
Li Li

Bug Description

Starting kernel ...

Booting Linux on physical CPU 0
Initializing cgroup subsys cpuset
Initializing cgroup subsys cpu
Linux version 3.5.0-8-highbank (buildd@meissa) (gcc version 4.7.1 (Ubuntu/Linaro 4.7.1-6ubuntu1) ) #8-Ubuntu SMP PREEMPT Sat Aug 4 08:03:52 UTC 2012 (Ubuntu 3.5.0-8.8-highbank 3.5.0)
CPU: ARMv7 Processor [413fc090] revision 0 (ARMv7), cr=10c5387d
CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache
Machine: Highbank, model: Calxeda Highbank
bootconsole [earlycon0] enabled
cma: CMA: reserved 16 MiB at 2e800000
Memory policy: ECC disabled, Data cache writealloc

CVE References

Ike Panhc (ikepanhc) wrote :
Download full text (7.6 KiB)

This does not happen on -25.40

Starting kernel ...

Booting Linux on physical CPU 0
Linux version 3.2.0-25-highbank (buildd@nihal) (gcc version 4.6.3 (Ubuntu/Linaro 4.6.3-1ubuntu5) ) #40-Ubuntu SMP PREEMPT Thu May 24 00:18:11 UTC 2012 (Ubuntu 3.2.0-25.40-highbank 3.2.18)
CPU: ARMv7 Processor [413fc090] revision 0 (ARMv7), cr=10c5387d
CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache
Machine: Highbank, model: Calxeda Highbank
Memory policy: ECC disabled, Data cache writealloc
PERCPU: Embedded 7 pages/cpu @c3410000 s5248 r8192 d15232 u32768
Built 1 zonelists in Zone order, mobility grouping on. Total pages: 1037583
Kernel command line: console=ttyAMA0 root=UUID=b369bf8b-1985-4845-a9c6-e6c84921b0fa nosplash earlyprintk
PID hash table entries: 4096 (order: 2, 16384 bytes)
Dentry cache hash table entries: 131072 (order: 7, 524288 bytes)
Inode-cache hash table entries: 65536 (order: 6, 262144 bytes)
Memory: 4089MB = 4089MB total
Memory: 4142428k/4142428k available, 44708k reserved, 3288064K highmem
Virtual kernel memory layout:
    vector : 0xffff0000 - 0xffff1000 ( 4 kB)
    fixmap : 0xfff00000 - 0xfffe0000 ( 896 kB)
    vmalloc : 0xf7000000 - 0xfee00000 ( 126 MB)
    lowmem : 0xc0000000 - 0xf6e00000 ( 878 MB)
    pkmap : 0xbfe00000 - 0xc0000000 ( 2 MB)
    modules : 0xbf000000 - 0xbfe00000 ( 14 MB)
      .text : 0xc0008000 - 0xc0475cf0 (4536 kB)
      .init : 0xc0476000 - 0xc049c480 ( 154 kB)
      .data : 0xc049e000 - 0xc04c21c0 ( 145 kB)
       .bss : 0xc04c21e4 - 0xc04f7b10 ( 215 kB)
SLUB: Genslabs=13, HWalign=32, Order=0-3, MinObjects=0, CPUs=4, Nodes=1
Preemptible hierarchical RCU implementation.
NR_IRQS:192
L310 cache controller enabled
l2x0: 16 ways, CACHE_ID 0x420000c8, AUX_CTRL 0x020b0000, Cache size: 4194304 B
Console: colour dummy device 80x30
Calibrating delay loop... 398.13 BogoMIPS (lpj=1990656)
pid_max: default: 32768 minimum: 301
Security Framework initialized
AppArmor: AppArmor initialized
Yama: becoming mindful.
Mount-cache hash table entries: 512
CPU: Testing write buffer coherency: ok
CPU0: thread -1, cpu 0, socket 9, mpidr 80000900
Calibrating local timer... 49.97MHz.
hw perfevents: enabled with ARMv7 Cortex-A9 PMU driver, 7 counters available
Setting up static identity map for 0x368388 - 0x3683d0
CPU1: Booted secondary processor
CPU1: thread -1, cpu 1, socket 9, mpidr 80000901
CPU1: Unknown IPI message 0x0
CPU2: Booted secondary processor
CPU2: thread -1, cpu 2, socket 9, mpidr 80000902
CPU2: Unknown IPI message 0x0
CPU3: Booted secondary processor
CPU3: thread -1, cpu 3, socket 9, mpidr 80000903
Brought up 4 CPUs
SMP: Total of 4 processors activated (1592.52 BogoMIPS).
CPU3: Unknown IPI message 0x0
devtmpfs: initialized
NET: Registered protocol family 16
Unpacking initramfs...
hw-breakpoint: found 5 (+1 reserved) breakpoint and 1 watchpoint registers.
hw-breakpoint: maximum watchpoint size is 4 bytes.
Serial: AMBA PL011 UART driver
fff36000.serial: ttyAMA0 at MMIO 0xfff36000 (irq = 52) is a PL011 rev3
console [ttyAMA0] enabled
bio: create slab <bio-0> at 0
SCSI subsystem initialized
NetLabel: Initializing
NetLabel: domain hash size = 128
NetLabel: protocols = UNLABELE...

Read more...

Ike Panhc (ikepanhc) wrote :
Download full text (7.6 KiB)

precise-26.41 also fine

Starting kernel ...

Booting Linux on physical CPU 0
Linux version 3.2.0-26-highbank (buildd@nihal) (gcc version 4.6.3 (Ubuntu/Linaro 4.6.3-1ubuntu5) ) #41-Ubuntu SMP PREEMPT Thu Jun 14 20:55:11 UTC 2012 (Ubuntu 3.2.0-26.41-highbank 3.2.19)
CPU: ARMv7 Processor [413fc090] revision 0 (ARMv7), cr=10c5387d
CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache
Machine: Highbank, model: Calxeda Highbank
Memory policy: ECC disabled, Data cache writealloc
PERCPU: Embedded 7 pages/cpu @c3410000 s5120 r8192 d15360 u32768
Built 1 zonelists in Zone order, mobility grouping on. Total pages: 1037583
Kernel command line: console=ttyAMA0 root=UUID=b369bf8b-1985-4845-a9c6-e6c84921b0fa nosplash earlyprintk
PID hash table entries: 4096 (order: 2, 16384 bytes)
Dentry cache hash table entries: 131072 (order: 7, 524288 bytes)
Inode-cache hash table entries: 65536 (order: 6, 262144 bytes)
Memory: 4089MB = 4089MB total
Memory: 4141784k/4141784k available, 45352k reserved, 3288064K highmem
Virtual kernel memory layout:
    vector : 0xffff0000 - 0xffff1000 ( 4 kB)
    fixmap : 0xfff00000 - 0xfffe0000 ( 896 kB)
    vmalloc : 0xf7000000 - 0xfee00000 ( 126 MB)
    lowmem : 0xc0000000 - 0xf6e00000 ( 878 MB)
    pkmap : 0xbfe00000 - 0xc0000000 ( 2 MB)
    modules : 0xbf000000 - 0xbfe00000 ( 14 MB)
      .text : 0xc0008000 - 0xc0510998 (5155 kB)
      .init : 0xc0511000 - 0xc053c400 ( 173 kB)
      .data : 0xc053e000 - 0xc05689e0 ( 171 kB)
       .bss : 0xc0568a04 - 0xc059f724 ( 220 kB)
SLUB: Genslabs=13, HWalign=32, Order=0-3, MinObjects=0, CPUs=4, Nodes=1
Preemptible hierarchical RCU implementation.
NR_IRQS:192
L310 cache controller enabled
l2x0: 16 ways, CACHE_ID 0x420000c8, AUX_CTRL 0x020b0000, Cache size: 4194304 B
Console: colour dummy device 80x30
Calibrating delay loop... 398.13 BogoMIPS (lpj=1990656)
pid_max: default: 32768 minimum: 301
Security Framework initialized
AppArmor: AppArmor initialized
Yama: becoming mindful.
Mount-cache hash table entries: 512
CPU: Testing write buffer coherency: ok
CPU0: thread -1, cpu 0, socket 9, mpidr 80000900
Calibrating local timer... 49.97MHz.
hw perfevents: enabled with ARMv7 Cortex-A9 PMU driver, 7 counters available
Setting up static identity map for 0x3c92a8 - 0x3c92f0
CPU1: Booted secondary processor
CPU1: thread -1, cpu 1, socket 9, mpidr 80000901
CPU1: Unknown IPI message 0x0
CPU2: Booted secondary processor
CPU2: thread -1, cpu 2, socket 9, mpidr 80000902
CPU2: Unknown IPI message 0x0
CPU3: Booted secondary processor
CPU3: thread -1, cpu 3, socket 9, mpidr 80000903
Brought up 4 CPUs
SMP: Total of 4 processors activated (1592.52 BogoMIPS).
CPU3: Unknown IPI message 0x0
devtmpfs: initialized
print_constraints: dummy:
NET: Registered protocol family 16
Trying to unpack rootfs image as initramfs...
hw-breakpoint: found 5 (+1 reserved) breakpoint and 1 watchpoint registers.
hw-breakpoint: maximum watchpoint size is 4 bytes.
Serial: AMBA PL011 UART driver
fff36000.serial: ttyAMA0 at MMIO 0xfff36000 (irq = 52) is a PL011 rev3
console [ttyAMA0] enabled
bio: create slab <bio-0> at 0
SCSI subsystem initialized
usbcore: registered new interface driver usb...

Read more...

Ike Panhc (ikepanhc) wrote :
Download full text (8.3 KiB)

Precise-27.43 also works fine

Starting kernel ...

Booting Linux on physical CPU 0
Initializing cgroup subsys cpuset
Initializing cgroup subsys cpu
Linux version 3.2.0-27-highbank (buildd@ain) (gcc version 4.6.3 (Ubuntu/Linaro 4.6.3-1ubuntu5) ) #43-Ubuntu SMP PREEMPT Fri Jul 6 16:48:52 UTC 2012 (Ubuntu 3.2.0-27.43-highbank 3.2.21)
CPU: ARMv7 Processor [413fc090] revision 0 (ARMv7), cr=10c5387d
CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache
Machine: Highbank, model: Calxeda Highbank
Memory policy: ECC disabled, Data cache writealloc
PERCPU: Embedded 7 pages/cpu @c3410000 s5280 r8192 d15200 u32768
Built 1 zonelists in Zone order, mobility grouping on. Total pages: 1037583
Kernel command line: console=ttyAMA0 root=UUID=b369bf8b-1985-4845-a9c6-e6c84921b0fa nosplash earlyprintk
PID hash table entries: 4096 (order: 2, 16384 bytes)
Dentry cache hash table entries: 131072 (order: 7, 524288 bytes)
Inode-cache hash table entries: 65536 (order: 6, 262144 bytes)
allocated 16748544 bytes of page_cgroup
please try 'cgroup_disable=memory' option if you don't want memory cgroups
Memory: 4089MB = 4089MB total
Memory: 4125264k/4125264k available, 61872k reserved, 3288064K highmem
Virtual kernel memory layout:
    vector : 0xffff0000 - 0xffff1000 ( 4 kB)
    fixmap : 0xfff00000 - 0xfffe0000 ( 896 kB)
    vmalloc : 0xf7000000 - 0xfee00000 ( 126 MB)
    lowmem : 0xc0000000 - 0xf6e00000 ( 878 MB)
    pkmap : 0xbfe00000 - 0xc0000000 ( 2 MB)
    modules : 0xbf000000 - 0xbfe00000 ( 14 MB)
      .text : 0xc0008000 - 0xc0534ed4 (5300 kB)
      .init : 0xc0535000 - 0xc05614a0 ( 178 kB)
      .data : 0xc0562000 - 0xc058f840 ( 183 kB)
       .bss : 0xc058f864 - 0xc05c8d24 ( 230 kB)
SLUB: Genslabs=13, HWalign=32, Order=0-3, MinObjects=0, CPUs=4, Nodes=1
Preemptible hierarchical RCU implementation.
NR_IRQS:192
L310 cache controller enabled
l2x0: 16 ways, CACHE_ID 0x420000c8, AUX_CTRL 0x020b0000, Cache size: 4194304 B
sched_clock: 32 bits at 150MHz, resolution 6ns, wraps every 28633ms
Console: colour dummy device 80x30
Calibrating delay loop... 398.13 BogoMIPS (lpj=1990656)
pid_max: default: 32768 minimum: 301
Security Framework initialized
AppArmor: AppArmor initialized
Yama: becoming mindful.
Mount-cache hash table entries: 512
Initializing cgroup subsys cpuacct
Initializing cgroup subsys memory
Initializing cgroup subsys devices
Initializing cgroup subsys freezer
Initializing cgroup subsys blkio
Initializing cgroup subsys perf_event
CPU: Testing write buffer coherency: ok
CPU0: thread -1, cpu 0, socket 9, mpidr 80000900
Calibrating local timer... 49.97MHz.
hw perfevents: enabled with ARMv7 Cortex-A9 PMU driver, 7 counters available
Setting up static identity map for 0x3e5758 - 0x3e57a0
CPU1: Booted secondary processor
CPU1: thread -1, cpu 1, socket 9, mpidr 80000901
CPU1: Unknown IPI message 0x0
CPU2: Booted secondary processor
CPU2: thread -1, cpu 2, socket 9, mpidr 80000902
CPU2: Unknown IPI message 0x0
CPU3: Booted secondary processor
CPU3: thread -1, cpu 3, socket 9, mpidr 80000903
Brought up 4 CPUs
CPU3: Unknown IPI message 0x0
SMP: Total of 4 processors activated (1592.52 BogoMIPS).
devtmpfs: initialized
prin...

Read more...

Ike Panhc (ikepanhc) wrote :
Download full text (8.3 KiB)

Looks like this issue only around quantal kernel

Starting kernel ...

Booting Linux on physical CPU 0
Initializing cgroup subsys cpuset
Initializing cgroup subsys cpu
Linux version 3.2.0-29-highbank (buildd@iara) (gcc version 4.6.3 (Ubuntu/Linaro 4.6.3-1ubuntu5) ) #46-Ubuntu SMP PREEMPT Fri Jul 27 20:03:53 UTC 2012 (Ubuntu 3.2.0-29.46-highbank 3.2.24)
CPU: ARMv7 Processor [413fc090] revision 0 (ARMv7), cr=10c5387d
CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache
Machine: Highbank, model: Calxeda Highbank
Memory policy: ECC disabled, Data cache writealloc
PERCPU: Embedded 7 pages/cpu @c3410000 s5280 r8192 d15200 u32768
Built 1 zonelists in Zone order, mobility grouping on. Total pages: 1037583
Kernel command line: console=ttyAMA0 root=UUID=b369bf8b-1985-4845-a9c6-e6c84921b0fa nosplash earlyprintk
PID hash table entries: 4096 (order: 2, 16384 bytes)
Dentry cache hash table entries: 131072 (order: 7, 524288 bytes)
Inode-cache hash table entries: 65536 (order: 6, 262144 bytes)
allocated 16748544 bytes of page_cgroup
please try 'cgroup_disable=memory' option if you don't want memory cgroups
Memory: 4089MB = 4089MB total
Memory: 4125264k/4125264k available, 61872k reserved, 3288064K highmem
Virtual kernel memory layout:
    vector : 0xffff0000 - 0xffff1000 ( 4 kB)
    fixmap : 0xfff00000 - 0xfffe0000 ( 896 kB)
    vmalloc : 0xf7000000 - 0xfee00000 ( 126 MB)
    lowmem : 0xc0000000 - 0xf6e00000 ( 878 MB)
    pkmap : 0xbfe00000 - 0xc0000000 ( 2 MB)
    modules : 0xbf000000 - 0xbfe00000 ( 14 MB)
      .text : 0xc0008000 - 0xc0534eec (5300 kB)
      .init : 0xc0535000 - 0xc05614a0 ( 178 kB)
      .data : 0xc0562000 - 0xc058f860 ( 183 kB)
       .bss : 0xc058f884 - 0xc05c8d24 ( 230 kB)
SLUB: Genslabs=13, HWalign=32, Order=0-3, MinObjects=0, CPUs=4, Nodes=1
Preemptible hierarchical RCU implementation.
NR_IRQS:192
L310 cache controller enabled
l2x0: 16 ways, CACHE_ID 0x420000c8, AUX_CTRL 0x020b0000, Cache size: 4194304 B
sched_clock: 32 bits at 150MHz, resolution 6ns, wraps every 28633ms
Console: colour dummy device 80x30
Calibrating delay loop... 398.13 BogoMIPS (lpj=1990656)
pid_max: default: 32768 minimum: 301
Security Framework initialized
AppArmor: AppArmor initialized
Yama: becoming mindful.
Mount-cache hash table entries: 512
Initializing cgroup subsys cpuacct
Initializing cgroup subsys memory
Initializing cgroup subsys devices
Initializing cgroup subsys freezer
Initializing cgroup subsys blkio
Initializing cgroup subsys perf_event
CPU: Testing write buffer coherency: ok
CPU0: thread -1, cpu 0, socket 9, mpidr 80000900
Calibrating local timer... 49.97MHz.
hw perfevents: enabled with ARMv7 Cortex-A9 PMU driver, 7 counters available
Setting up static identity map for 0x3e58e8 - 0x3e5930
CPU1: Booted secondary processor
CPU1: thread -1, cpu 1, socket 9, mpidr 80000901
CPU1: Unknown IPI message 0x0
CPU2: Booted secondary processor
CPU2: thread -1, cpu 2, socket 9, mpidr 80000902
CPU2: Unknown IPI message 0x0
CPU3: Booted secondary processor
CPU3: thread -1, cpu 3, socket 9, mpidr 80000903
Brought up 4 CPUs
CPU3: Unknown IPI message 0x0
SMP: Total of 4 processors activated (1592.52 BogoMIPS).
devtm...

Read more...

Ike Panhc (ikepanhc) on 2012-08-09
Changed in linux (Ubuntu):
assignee: nobody → Li Li (lli5)
Ike Panhc (ikepanhc) on 2012-08-09
Changed in linux (Ubuntu):
importance: Undecided → High
Li Li (lli5) wrote :

There're several problems in hb kernel.
1) CONFIG_DEBUG_HIGHBANK_UART is not enabled
2) HB_DEBUG_LL_VIRT_BASE resides in vmalloc area, wasting memory
3) arch/arm/mach-highbank/include/mach/debug-macro.S uses the predefined phys/virt uart io address directly - should calculate the value from HB_DEBUG_LL_VIRT_BASE instead.

1) is critical, which ensures 0xfee36000 is mapped to 0xfff36000 so that printch works for earlyprintk.

Li Li (lli5) wrote :

Ike, can you please add the following line to highbank config file? Thanks!

CONFIG_DEBUG_HIGHBANK_UART=y

Li Li (lli5) on 2012-08-13
Changed in linux (Ubuntu):
status: Confirmed → In Progress
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.5.0-11.11

---------------
linux (3.5.0-11.11) quantal-proposed; urgency=low

  [ Andy Whitcroft ]

  * [Config] enable CONFIG_X86_X32=y

  [ Cypress Semiconductor Corporation ]

  * SAUCE: input: Cypress PS/2 Trackpad mouse driver
    - LP: #978807
  * SAUCE: input: Cypress PS/2 Trackpad link driver into psmouse-base
    - LP: #978807

  [ Dann Frazier ]

  * [Config] compile the rtc-pl031 driver as static on the highbank kernel
    flavour
    - LP: #1035110

  [ Ike Panhc ]

  * [Config] Enable CONFIG_DEBUG_HIGHBANK_UART for highbank
    - LP: #1034781

  [ Kamal Mostafa ]

  * SAUCE: input: Cypress PS/2 Trackpad code style cleanup
    - LP: #978807
  * SAUCE: input: Cypress PS/2 Trackpad eliminate dead code
    - LP: #978807
  * SAUCE: input: Cypress PS/2 Trackpad fix no-config stubs
    - LP: #978807
  * SAUCE: input: Cypress PS/2 Trackpad set default debug_level=0
    - LP: #978807
  * SAUCE: [Config] add MOUSE_PS2_CYPRESS=y
    - LP: #978807

  [ Kees Cook ]

  * SAUCE: Yama: access task_struct->comm directly
  * SAUCE: Yama: add link restrictions
  * SAUCE: security: unconditionally chain to Yama LSM

  [ Seth Forshee ]

  * SAUCE: (drop after 3.6) irq_remap: disable IRQ remapping if any IOAPIC
    lacks an IOMMU
    - LP: #1034459

  [ Stefan Bader ]

  * (config) Enable getabis to use local package copies

  [ Tim Gardner ]

  * rebase to v3.5.2

  [ Upstream Kernel Changes ]

  * rds: set correct msg_namelen
    - LP: #1031112
    - CVE-2012-2340
  * rebase to v3.5.2
    - LP: #1027789
    - LP: #1001251
 -- Leann Ogasawara <email address hidden> Thu, 16 Aug 2012 08:52:09 -0700

Changed in linux (Ubuntu Quantal):
status: In Progress → Fix Released

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers